#addition "mod_qpc.hsp"
#module mod_AutoFPS
#uselib "kernel32.dll"
#func Sleep "Sleep" int
#uselib "winmm.dll"
#ifdef timeGetTimeDouble
#define timeGetTime timeGetTimeDouble
#else
#cfunc timeGetTime "timeGetTime"
#endif
#define CurrentTime (1.0*timeGetTime@mod_AutoFPS())
#func timeBeginPeriod "timeBeginPeriod" int

#deffunc autoFps_SetFPS int fps
    if StartTime == 0 : StartTime = CurrentTime
    SampleCount = fps*3
    FrameWait = 1000.0/fps
    NextDrawTime = CurrentTime + FrameWait
    dimtype LapTime, vartype("double"), 1
    DrawnFrames = 0
    LastDrawStart = CurrentTime
    return

#deffunc autoFps_StartInternal
    if CurrentTime < NextDrawTime  : Sleep 1 : return 1
    NextDrawTime += FrameWait : StartInternalTime = CurrentTime
    return 0

#deffunc autoFps_StartDraw
    CallCount++
    if /* CallCount\8=0 | */ NextDrawTime>CurrentTime {
        LapTime(DrawnFrames\SampleCount) = CurrentTime - LastDrawStart
        LastDrawStart = CurrentTime
        DrawnFrames++
        return 0
    }
    return 1

#define global autoFps_CurrentFps _autoFps_CurrentFps()
#defcfunc _autoFps_CurrentFps
    t = 0.0
    repeat Length(LapTime)
        t+=LapTime.cnt
    loop
    return 1000.0/limit(t*length(LapTime),1,$FFFFFF)

#define global autoFps_mmtimer (CurrentTime@mod_autoFps-StartTime@mod_autoFps)
#global



